package com.hotwj.platform.driverManagement.driverWorkExperience.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hotwj.platform.driverManagement.driverWorkExperience.domain.HotDriverWorkExperience;
import com.hotwj.platform.driverManagement.driverWorkExperience.domain.bo.HotDriverWorkExperienceBo;
import com.hotwj.platform.driverManagement.driverWorkExperience.domain.vo.HotDriverWorkExperienceVo;
import com.hotwj.platform.driverManagement.driverWorkExperience.mapper.HotDriverWorkExperienceMapper;
import com.hotwj.platform.driverManagement.driverWorkExperience.service.IHotDriverWorkExperienceService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 驾驶员工作经历Service业务层处理
 *
 * @author shihongwei
 * @date 2025-12-15
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class HotDriverWorkExperienceServiceImpl implements IHotDriverWorkExperienceService {

    private final HotDriverWorkExperienceMapper baseMapper;

    /**
     * 查询驾驶员工作经历
     *
     * @param id 主键
     * @return 驾驶员工作经历
     */
    @Override
    public HotDriverWorkExperienceVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询驾驶员工作经历列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 驾驶员工作经历分页列表
     */
    @Override
    public TableDataInfo<HotDriverWorkExperienceVo> queryPageList(HotDriverWorkExperienceBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<HotDriverWorkExperience> lqw = buildQueryWrapper(bo);
        Page<HotDriverWorkExperienceVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的驾驶员工作经历列表
     *
     * @param bo 查询条件
     * @return 驾驶员工作经历列表
     */
    @Override
    public List<HotDriverWorkExperienceVo> queryList(HotDriverWorkExperienceBo bo) {
        LambdaQueryWrapper<HotDriverWorkExperience> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<HotDriverWorkExperience> buildQueryWrapper(HotDriverWorkExperienceBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<HotDriverWorkExperience> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(HotDriverWorkExperience::getId);
        lqw.eq(bo.getCompanyId() != null, HotDriverWorkExperience::getCompanyId, bo.getCompanyId());
        lqw.eq(bo.getDriverId() != null, HotDriverWorkExperience::getDriverId, bo.getDriverId());
        lqw.eq(bo.getStartDate() != null, HotDriverWorkExperience::getStartDate, bo.getStartDate());
        lqw.eq(bo.getEndDate() != null, HotDriverWorkExperience::getEndDate, bo.getEndDate());
        lqw.eq(StringUtils.isNotBlank(bo.getEmployer()), HotDriverWorkExperience::getEmployer, bo.getEmployer());
        lqw.eq(StringUtils.isNotBlank(bo.getJobTitle()), HotDriverWorkExperience::getJobTitle, bo.getJobTitle());
        lqw.eq(StringUtils.isNotBlank(bo.getDescription()), HotDriverWorkExperience::getDescription, bo.getDescription());
        lqw.eq(bo.getIsDeleted() != null, HotDriverWorkExperience::getIsDeleted, bo.getIsDeleted());
        return lqw;
    }

    /**
     * 新增驾驶员工作经历
     *
     * @param bo 驾驶员工作经历
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(HotDriverWorkExperienceBo bo) {
        HotDriverWorkExperience add = MapstructUtils.convert(bo, HotDriverWorkExperience.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改驾驶员工作经历
     *
     * @param bo 驾驶员工作经历
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(HotDriverWorkExperienceBo bo) {
        HotDriverWorkExperience update = MapstructUtils.convert(bo, HotDriverWorkExperience.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(HotDriverWorkExperience entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除驾驶员工作经历信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
